// RF ģĲΪ FSK  433.5MHz 1.2KBPS +/-10PPM, Ƶƫ20KHz ƴ41.2KHz 
//			ʹAFCʹCRC PH + FIFO ģʽ
// ÿӷĹ̶Ϊ 0x41,0x42,0x43,0x44,0x45,0x46,0x47,0x48,0x49,0x6d, 
//                              0x6d = (0x41 +0x42 +0x43 +0x44 +0x45 +0x46 +0x47 + 0x48 +0x49)
// MCU : Microchip high performance 8 bit MCU :PIC16F689

#include<pic.h>
#include<math.h>


const unsigned char tx_test_data[10] = {0x41,0x42,0x43,0x44,0x45,0x46,0x47,0x48,0x49,0x6d};  // ÿ뷢Ĺ̶ݵĲźţ10ǰ9ݵУ



#define SI4432_PWRSTATE_READY		01		// ģ Ready ״̬
#define SI4432_PWRSTATE_TX		0x09		// ģ ״̬
#define SI4432_PWRSTATE_RX		05		// ģ ״̬
#define SI4432_PACKET_SENT_INTERRUPT	04		// ģ ж
#define SI4432_Rx_packet_received_interrupt   0x02      // ģ յݰж

#define  TX1_RX0	spi_rw(0x0e|0x80, 0x01)		// ״̬߿ض
#define  TX0_RX1	spi_rw(0x0e|0x80, 0x02)		// ״̬߿ض
#define  TX0_RX0	spi_rw(0x0e|0x80, 0x00)         // Ƿ䣬״̬߿ض



#define  nIRQ           	RC0		// MCU 
#define  SDO	         	RC1		// MCU 
#define  nSEL			RC2		// MCU 
#define  SDI           		RC3		// MCU 
#define  SCK			RC4		// MCU 
#define  SDN			RC5		// MCU 

#define nIRQ_set		TRISC0		// IOڵ룬ļĴ
#define SDO_set			TRISC1		// IOڵ룬ļĴ
#define nSEL_set		TRISC2		// IOڵ룬ļĴ
#define SDI_set			TRISC3		// IOڵ룬ļĴ
#define SCK_set			TRISC4		// IOڵ룬ļĴ	
#define SDN_set			TRISC5		// IOڵ룬ļĴ


#define INPUT			1
#define OUTPUT			0

unsigned char count_50hz;

unsigned char ItStatus1, ItStatus2;
unsigned char rf_timeout;

unsigned char rx_buf[15];


typedef struct 
{
	
	unsigned char reach_1s				: 1;
	unsigned char rf_reach_timeout			: 1;
	unsigned char is_tx				: 1;
	
	
}	FlagType;

FlagType	                Flag;



void rx_data(void);

void tx_data(void);

unsigned char spi_byte(unsigned char data);
unsigned char spi_rw(unsigned char addr, unsigned char data);

void SI4432_init(void);

void delay_1ms(unsigned char time);

void port_init(void); 

void timer_init(void);

void main()
{ 
	

	unsigned char  i, j, chksum;

	OSCCON = 0X70;	// ʹڲ 8M crystal
	
	WDTCON = 0X00;  // Ź
	
	
	port_init();  	// IO ڳʼ
 
 	
 	SDN = 1;
 	delay_1ms(10);	// RF ģ鸴λ
 	
 	SDN = 0;
 	delay_1ms(200);	// ʱ150ms RF ģ빤״̬
 
 	
 	SI4432_init();  // RF ģʼ
 	
 	TX0_RX0;	// ߿زڷ䣬״̬
 
	
	timer_init();
	
	count_50hz = 0;
	Flag.reach_1s = 0;

	INTCON = 0xc0;   // enable interrupt
	
	
	while(1)
	{		
		if(Flag.reach_1s)
		{
			Flag.reach_1s = 0;
			tx_data();		// ÿһʱ䣬һݣ Acknowledge ź
		}
		if(!Flag.is_tx)
		{
			if(!nIRQ)
			{ 	
				ItStatus1 = spi_rw(0x03,0x00);	// ж											//read the Interrupt Status1 register
				ItStatus2 = spi_rw(0x04,0x00);	// ж
				
				SCK = 0;
				nSEL = 0;
				spi_byte(0x7f);		// ӻ
				for(i = 0;i<10;i++)	
				{
					rx_buf[i] = spi_byte(0x00);
				}
				nSEL = 1;
				
				spi_rw(0x07|0x80, SI4432_PWRSTATE_READY);	// ݽɣ˳ģʽ
									
				chksum = 0;
				for(i=0;i<9;i++)		// Checksum
        			chksum += rx_buf[i];          	 		
        				
        			
     				if(( chksum == rx_buf[9] )&&( rx_buf[0] == 0x41 ))
     					
     				{
     					
     					;   // յ
        			} 
        			else
        			{
        				rx_data();     // յݲԣҪʼ
        			}	
        		 
        		}	
		}	
	}	
}


void delay_1ms(unsigned char time)
{
	unsigned char i,k;
	for(k = 0; k< time; k++)
	{
		for(i = 0; i<130; i++)
		{
			NOP();
		}
	}		
}	


void timer_init(void)
{
	T1CON = 0x31; 

	TMR1IE = 1;
	TMR1L = 0x78;	 //ʱжϳʼ
	TMR1H = 0xec;
	
}

void interrupt ISR_timer(void)
{
 
 	unsigned char i;
	if(TMR1IF)
   	{
  
   		TMR1L = 0x78;		// 20ms Ķʱ
   		TMR1H = 0xec;
	
		rf_timeout++;
		if(rf_timeout == 25)
		{
			Flag.rf_reach_timeout = 1;	// 0.5룬3Timeoutʱ䣬չôRam
		}	
		count_50hz++;
    		if(count_50hz==50)  // 
     		{
       			count_50hz=0;
       			Flag.reach_1s = 1;	//һ Ķʱ
       			
     		}		
     		
    		TMR1IF=0;
	}
	
}  

void port_init(void) 
{ 
 	ANSEL = 0;
 	ANSELH = 0;	// ʹãͣãյAD	
 	WPUA = 0;	// û
 	IOCA = 0;  // ûIOж

 
	nIRQ_set  = INPUT;
	SDO_set   = INPUT;
	nSEL_set  = OUTPUT;
	SDI_set	  = OUTPUT;
	SCK_set	  = OUTPUT;
	SDN_set	  = OUTPUT;
	TRISB5 = OUTPUT;
}	

	



void SI4432_init(void)
{
	
	ItStatus1 = spi_rw(0x03,0x00);		// RFģж	
	ItStatus2 = spi_rw(0x04,0x00);
	
	spi_rw(0x06|0x80, 0x00);  //  رղҪж
	
	spi_rw(0x07|0x80, SI4432_PWRSTATE_READY);   //  Ready ģʽ
	 


	spi_rw(0x09|0x80, 0x7f);  //  ص= 12P

	spi_rw(0x0a|0x80, 0x05);	// رյƵ
	spi_rw(0x0b|0x80, 0xea); // GPIO 0 ͨ
	spi_rw(0x0c|0x80, 0xea); //GPIO 1 ͨ
	
	spi_rw(0x0d|0x80, 0xf4);  // /GPIO 2 յ
	
	
	
	spi_rw(0x70|0x80, 0x2c);  
	spi_rw(0x1d|0x80, 0x40);  // ʹ afc
		
	// 1.2K bps setting
	spi_rw(0x1c|0x80, 0x2c);	// øSilabs Excel
	
	
	spi_rw(0x20|0x80, 0x41);   
	 
	spi_rw(0x21|0x80, 0x60); //
	spi_rw(0x22|0x80, 0x27);// 
	spi_rw(0x23|0x80, 0x52); //
	spi_rw(0x24|0x80, 0x00); //
	spi_rw(0x25|0x80, 0x07); //
	
	spi_rw(0x2a|0x80, 0x0f);
	spi_rw(0x6e|0x80, 0x09);
	spi_rw(0x6f|0x80, 0xd5);
	
	//1.2K bps setting end		
	
	
		spi_rw(0x30|0x80, 0x8c);   // ʹPH+ FIFOģʽλǰ棬ʹCRCУ
	 
					
		spi_rw(0x32|0x80, 0xff);  // byte0, 1,2,3 Ϊͷ
	 
		spi_rw(0x33|0x80, 0x42);//  byte 0,1,2,3 ͷ룬ͬ3,2 ͬ
	

		
	spi_rw(0x34|0x80, 16);  // 16NibblePreamble
	spi_rw(0x35|0x80, 0x20);  // Ҫ4nibblePreamble
	spi_rw(0x36|0x80, 0x2d);  // ͬΪ 0x2dd4
	spi_rw(0x37|0x80, 0xd4);
	spi_rw(0x38|0x80, 0x00);
	spi_rw(0x39|0x80, 0x00);
	spi_rw(0x3a|0x80, 's');  // ͷΪ swwx"
	spi_rw(0x3b|0x80, 'w');
	spi_rw(0x3c|0x80, 'w');
	spi_rw(0x3d|0x80, 'x');
	spi_rw(0x3e|0x80, 10);  // ܹ10ֽڵ
	spi_rw(0x3f|0x80, 's'); // ҪУͷΪswwx"
	spi_rw(0x40|0x80, 'w');
	spi_rw(0x41|0x80, 'w');
	spi_rw(0x42|0x80, 'x');
	spi_rw(0x43|0x80, 0xff);  // ͷ1,2,3,4 λҪУ
	spi_rw(0x44|0x80, 0xff);  // 
	spi_rw(0x45|0x80, 0xff);  // 
	spi_rw(0x46|0x80, 0xff);  // 
	spi_rw(0x6d|0x80, 0x07);  // Ϊʷ

	spi_rw(0x79|0x80, 0x0);  // ҪƵ
	spi_rw(0x7a|0x80, 0x0);  // ҪƵ
	
	
	spi_rw(0x71|0x80, 0x22); // 䲻Ҫ CLKFiFo  FSKģʽ
			
	spi_rw(0x72|0x80, 0x30);  // ƵƫΪ 30KHz
	

	spi_rw(0x73|0x80, 0x0);  // ûƵƫ
	spi_rw(0x74|0x80, 0x0);  // ûƵƫ
	
	
		
	spi_rw(0x75|0x80, 0x53);  // Ƶ 433.5
	spi_rw(0x76|0x80, 0x57);  // 
	spi_rw(0x77|0x80, 0x80);
			
		
}




  
void rx_data(void)
{	
	unsigned char i, chksum;
	Flag.is_tx = 0;
	
	spi_rw(0x07|0x80, SI4432_PWRSTATE_READY);	// Ready ģʽ
	delay_1ms(5);		//

	TX0_RX1;		// ߿
	
	spi_rw(0x08|0x80, 0x03);  //巢䣬ջ
	spi_rw(0x08|0x80, 0x00);  //巢䣬ջ
		
	spi_rw(0x07|0x80,SI4432_PWRSTATE_RX );  // RF ģģʽ
	
	spi_rw(0x05|0x80, SI4432_Rx_packet_received_interrupt);  // RFģյݺ󣬲ж
		
	ItStatus1 = spi_rw(0x03,0x00);		//ежϱ־
	ItStatus2 = spi_rw(0x04,0x00);		//ежϱ־
		
}	

void tx_data(void)
{
	unsigned char i;
	
	Flag.is_tx = 1;

	spi_rw(0x07|0x80, SI4432_PWRSTATE_READY);	// rf ģReady ģʽ

	TX1_RX0;		//߿صķ
	
	delay_1ms(5);		// ʱ 5ms, ϵͳȶ
	
	

	spi_rw(0x08|0x80, 0x03);  // 
	spi_rw(0x08|0x80, 0x00);  // 巢䣬ջ
	
	

		
	spi_rw(0x34|0x80, 40);  // 40Nibble ǰ
	spi_rw(0x3e|0x80, 10);  // ܹ10ֽڵ
  	for (i = 0; i<10; i++)
	{
		spi_rw(0x7f|0x80, tx_test_data[i]); 	// Ҫ뻺
	}
	spi_rw(0x05|0x80, SI4432_PACKET_SENT_INTERRUPT);	// ݷ󣬲ж
	ItStatus1 = spi_rw(0x03,0x00);		// RFģж	
	ItStatus2 = spi_rw(0x04,0x00);
	spi_rw(0x07|0x80, SI4432_PWRSTATE_TX);  // 뷢ģʽ
	
	rf_timeout = 0;
	Flag.rf_reach_timeout = 0;
	while(nIRQ)		// ȴж
	{
		
		if(Flag.rf_reach_timeout)
		{
			
			SDN  = 1;		//0.5뻹ûж,RFģ鹤¸λʼģ
			delay_1ms(10);
			SDN = 0;
			delay_1ms(200);
			
			SI4432_init();
			break;		// ǿ
		}
			
	}	
  	rx_data();		//rf ɣģʽ
}	


unsigned char spi_byte(unsigned char data)
{
	unsigned char i;
	
	for (i = 0; i < 8; i++)		// SCK  SDIһֽڵͬ¶ȡ1ֽڵ
	{				// ûаnSELĿ
		if (data & 0x80)
			SDI = 1;
		else
			SDI = 0;
			
		data <<= 1;
		SCK = 1;
		
		if (SDO)
			data |= 0x01;
		else
			data &= 0xfe;
			
		SCK = 0;
	}
	
	return (data);
}
//-------------------------------------------
unsigned char spi_rw(unsigned char addr, unsigned char data)
{
	unsigned char i;
	
	SCK = 0;
	nSEL = 0;
	
	for (i = 0; i < 8; i++) 
	{
		if (addr & 0x80)
			SDI = 1;
		else
			SDI = 0;
		addr <<= 1;
		SCK = 1;
		asm("NOP");
		SCK = 0;
	}
	
	for (i = 0; i < 8; i++) 
	{
		if (data & 0x80)
			SDI = 1;
		else
			SDI = 0;
		data <<= 1;
		SCK = 1;
		if (SDO)
			data |= 0x01;
		else
			data &= 0xfe;
		SCK = 0;
	}
	nSEL = 1;
	SCK = 1;
	return (data);
}


// song end 

  

