/******************************************************************************
 *                             Include File Section                           *
 ******************************************************************************/
#include "flash.h"

#define clear_wdt() {wdtr = 0x00; asm("nop"); wdtr = 0xFF;};

//#pragma section program ProStart
void flash_wrt(unsigned char *tp,unsigned char num,unsigned int flash_addr)
{
	unsigned char *address;
	unsigned char i;
	asm("fclr i");  //intterrupt disable
	fmr01 = 0;
	fmr01 = 1;		//cpu rewrite mode enable
	fmr02 = 0;		//ew0 mode
	//fmr02 = 1;  	//data flash start
	if(flash_addr>=0x3000&&flash_addr<0x3400)//block a
	{	
		fmr14 = 1;  
		fmr14 = 0;		//block a enable
	}
	else if(flash_addr>=0x3400&&flash_addr<0x3800)//block b
	{
		fmr15 = 1;
		fmr15 = 0;      //block b enable
	}
	else if(flash_addr>=0x3800&&flash_addr<0x3c00)//block c
	{
		fmr16 = 1;
		fmr16 = 0;      //block c enable
	}
	else if(flash_addr>=0x3c00&&flash_addr<0x4000)//block d
	{
		fmr17 = 1;
		fmr17 = 0;      //block d enable
	}

	 //fmr00 = 1;
	 //fmr00 = 0;
	 for(i=0;i<num;i++)
	 {
		clear_wdt();		//幷Ҫ
		address = (unsigned char*)(flash_addr+i);
	 	*address=0x40;		//writing instruction
	 	*address=*(tp+i);
	 	while(!fst7_fst)
                {
                    clear_wdt();		//幷Ҫ
	        }
	 }
	 fmr01 = 0;
	 asm("fset i");  //intterrupt enable
} 

//#pragma section program ProStart
void flash_read(unsigned char *tp,unsigned char num,unsigned int flash_addr)
{
	unsigned char *address;
	unsigned char i;
	asm("fclr i");  //intterrupt disable
	 //fmr00 = 1;
	 //fmr00 = 0;
	 for(i=0;i<num;i++)
	 {
		address = (unsigned char*)(flash_addr+i);
	 	*address=0x20;		//read instruction
	 	*(tp+i)=*address;
	 }
	 asm("fset i");	
}

//#pragma section program ProStart
void flash_erease(unsigned int flash_blk)
{
	unsigned char *address;
	asm("fclr i");  //intterrupt disable
	fmr01 = 0;
	fmr01 = 1;		//cpu rewrite mode enable
	fmr02 = 0;		//ew0 mode

	if(flash_blk>=0x3000&&flash_blk<0x3400)//block a
	{	
		fmr14 = 1;  
		fmr14 = 0;		//block a enable
	}
	else if(flash_blk>=0x3400&&flash_blk<0x3800)//block b
	{
		fmr15 = 1;
		fmr15 = 0;      //block b enable
	}
	else if(flash_blk>=0x3800&&flash_blk<0x3c00)//block c
	{
		fmr16 = 1;
		fmr16 = 0;      //block c enable
	}
	else if(flash_blk>=0x3c00&&flash_blk<0x4000)//block d
	{
		fmr17 = 1;
		fmr17 = 0;      //block d enable
	}
	address=(unsigned char*)flash_blk;
	fmr20=1;
	fmr22=1;
	asm("fset i");	
	clear_wdt();		//幷Ҫ
	*address=0x20;		//erease block 
	*address=0xd0;
	while(!fst7_fst)
        {
            clear_wdt();		//幷Ҫ
	}
        
	if(fst5)//в,ٲһ
	{
		asm("fclr i");  //intterrupt disable
		fmr01 = 0;
		fmr01 = 1;		//cpu rewrite mode enable
		fmr02 = 0;		//ew0 mode

		if(flash_blk>=0x3000&&flash_blk<0x3400)//block a
		{	
			fmr14 = 1;  
			fmr14 = 0;		//block a enable
		}
		else if(flash_blk>=0x3400&&flash_blk<0x3800)//block b
		{
			fmr15 = 1;
			fmr15 = 0;      //block b enable
		}
		else if(flash_blk>=0x3800&&flash_blk<0x3c00)//block c
		{
			fmr16 = 1;
			fmr16 = 0;      //block c enable
		}
		else if(flash_blk>=0x3c00&&flash_blk<0x4000)//block d
		{
			fmr17 = 1;
			fmr17 = 0;      //block d enable
		}
		address=(unsigned char*)flash_blk;
		fmr20=1;
		fmr22=1;
		asm("fset i");	
		clear_wdt();		//幷Ҫ
		*address=0x20;		//erease block 
		*address=0xd0;
		while(!fst7_fst)
                {
                    clear_wdt();		//幷Ҫ
                }
	}	
	fmr01 = 0;
}
